## eternal-lands-1.9.6.1.tar.gz

=== CMakeLists.txt ===
# CMAKE file for Eternal Lands
#
# Create a build sub-directory and move into it
#
# To build a normal release version
#   cmake <path to source>
#
# Build Debug vesion
#   cmake -DCMAKE_BUILD_TYPE=debug <path to source>
#
# To specify a non-default exec name include -DEXEC, for example "-DEXEC=el.$(uname -m).linux.bin"
# To enable local CPU architecture optimisation include "-DMARCHNATIVE=On"
# To enable runtime GCC address sanitization include -DADDRSANITISER=On
#
# Example if located in source directory:
#   mkdir -p build && cd build
#   cmake -DCMAKE_BUILD_TYPE=debug -DEXEC=el.$(uname -m).linux.bin -DMARCHNATIVE=On -DADDRSANITISER=On ..
#   make
#
# Example for windows using msys2
#   cmake -G "MSYS Makefiles" -DCMAKE_INCLUDE_PATH="/mingw64/local/include" -DCMAKE_LIBRARY_PATH="/mingw64/local/lib" ..
#
# Example for FreeBSD (sorry about the iconv hack)
#	cmake -DLOCAL_NLOHMANN_JSON=On ../Eternal-Lands/ -DIconv_LIBRARIES="-L/usr/local/lib -liconv"
#

cmake_minimum_required(VERSION 3.5.0)

project (Eternal-Lands)

# standard options, some that also set source files to build
OPTION(CUSTOM_UPDATE "Allows autoupdating of custom look information" On)
OPTION(FSAA "Adds support for full screen anti-aliasing using OpenGL multisampling." On)
OPTION(JSON_FILES "Switch existing binary user config files to JSON format." On)
OPTION(LOCAL_NLOHMANN_JSON "Enable if you want to use an embedded copy of nlohmann_json, placed in the nlohmann_json sub-directory of the source." Off)
OPTION(MARCHNATIVE "Enable -march=native compiler flag, for when not building a portable executable." Off)
OPTION(ADDRSANITISER "Enable the gcc address sanitisation options to do run-time checking." Off)
OPTION(TTF "Add the ability to use True Type system fonts." On)
OPTION(USE_SSL "Encrypt the traffic with the server." On)
OPTION(PACKET_COMPRESSION "Add support for compressed data packets from the proxy server" On)

# standard options
add_definitions(
	-DCLUSTER_INSIDES				# Group objects into separate clusters for clipping on inside maps
	-DCUSTOM_LOOK					# allows you to customize your look.
	-DFUZZY_PATHS					# Makes Tab Map walking not always follow exaclty the same path
	-DNEW_SOUND					# Enables extended sound effects system
	-DPNG_SCREENSHOT				# make screenshots in W3C's PNG format in game, requires libpng
	-DUSE_INLINE					# enable some optimizations to use inline functions instead of pure function calls
	# new for 1.9.0 release
	-DBANDWIDTH_SAVINGS				# enable bandwidth saving changes for message protocol
	# new for 1.9.2 release
	-DANIMATION_SCALING				# Adds support for animation scaling, depending on the number of animation commands in the actor queue.
	# new for 1.9.3 release
	-DFASTER_MAP_LOAD				# Enables optimizations to speed up the process of switching between maps
	-DFASTER_STARTUP				# An attempt to reduce the startup time of EL somewhat
	-DMIDDLE_MOUSE_PASTE			# Paste using the middle mouse button from the primary buffer on X systems
	# new for 1.9.4 release
	-DNEW_EYES						# Support for different eye colors, needs new data files
	# proposed for next release
	-DNEW_CURSOR					# New coloured cursors made by Emajekral (Experimental).  An old unused feature. Derive cursor2.dss from http://users.on.net/~gingerman/sky_cursor-textures.zip (cursor2.bmp + alpha).
)


# Testing options (these options are possible for the a future release and should be tested)
add_definitions(
#	-DANTI_ALIAS					# allows to enable/disable anti-aliasing in the ini file
#	-DDYNAMIC_ANIMATIONS			# (appears broken) Synchronizes animation to FPS instead of a fixed timer
#	_DEXT_ACTOR_DICT				# Removes remaining hard-coded actor def dictionaries - requires updated actor defs files (http://el.grug.redirectme.net/actor_defs.zip)
#	-DNEW_ALPHA						# (undocumented)
#	-DUSE_SIMD						# Enables usage of simd instructions
)

# Machine specific options (fixes or performance enhancements)
add_definitions(
#	-DEL_BIG_ENDIAN					# Enable big-endian code (automatically detected for OSX)
#	-DNO_PF_MACRO					# Use a function instead of a macro for pf_get_tile()
#	-DSIMPLE_LOD					# enable a simplistic distance culling to improve performance
#	-DSOUND_FORK_BUGFIX				# needed for current linux static build to prevent crash when forking in url.c after F2 press and sound/music enabled
#	-DUSE_ALGETSOURCEI_AL_BUFFER	# disable to workaround issue with newer openal versions (also works on older versions), enable to restore original usage of alGetSourcei(pSource->source, AL_BUFFER, &buffer) for sound
)

# Debug options
add_definitions(
#	-DCONTEXT_MENUS_TEST			# Enable "#cmtest" command to help test/demo the context menu code
#	-DDEBUG							# (undocumented)
#	-DDEBUG_XML						# Enables missing (optional) XML string property messages
#	-DDEBUG_POINT_PARTICLES			# (undocumented)
#	-DDEBUG_TIME					# Fakes the acceleration of time for use in debugging shadows and the like.
#	-DDEBUG_MAP_SOUND				# Adds (some??) map boundary areas to tab maps and additional logging to stdout
#	-DECDEBUGWIN					# press ctrl-alt-c to open the Eye Candy debug window: trigger most effects without casting spells or server side events
#	-DEXTRA_DEBUG					# (undocumented)
#	-DMEMORY_DEBUG					# gather information about memory allocation and freeing
#	-DMISSILES_DEBUG				# Enables debug for missiles feature. It will create a file missiles_log.txt file in your settings directory.
#	-DMUTEX_DEBUG					# (undocumented)
#	-DOPENGL_TRACE					# make far more frequent checks for OpenGL errors (requires -DDEBUG to be of any use). Will make error_log.txt a lot larger.
#	-DTIMER_CHECK					# (undocumented)
#	-D_EXTRA_SOUND_DEBUG			# Enable debug for sound effects
)

# Other options (Experimental, unfinished, defunct or otherwise unknown)
add_definitions(
#	-DPAWN							# Experimental, not for release, will need server support to function properly. This *will* eat your cat. You've been warned. Enables the Pawn abstract machine.
#	-DUID							# use unique ID sent from server for custom looks. (INCOMPLETE)
#	-DUSE_ACTORS_OPTIMIZER			# Enables actor optimizations
#	-DWRITE_XML						# dangerous to use, will wipe out some XML files that are part of the main game download
)

# Set the path from the git root to the sours files
set(SD "")

# Get compiler flags for used libraries
include(cmake/FindSDL2.cmake)
include(cmake/FindSDL2_image.cmake)
include(cmake/FindSDL2_net.cmake)
set(OpenGL_GL_PREFERENCE LEGACY)
find_package(OpenGL REQUIRED)
find_package(OpenAL REQUIRED)
find_package(ZLIB REQUIRED)
find_package(PNG REQUIRED)
find_package(LibXml2 REQUIRED)
if (CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	find_package(X11 REQUIRED)
endif()
if (CMAKE_SYSTEM_NAME MATCHES "Windows")
	find_package(Iconv REQUIRED)
endif()
# these definitions were re-used from Xapher's opengl client
include(cmake/FindVorbis.cmake)
include(cmake/FindVorbisFile.cmake)
include(cmake/FindCal3d.cmake)
if (TTF)
	include(cmake/FindSDL2TTF.cmake)
endif()
if (USE_SSL)
	find_package(OpenSSL REQUIRED)
endif()

# require the nlohmann_json package if building for json files
if (JSON_FILES)
	# if enabled use a local copy of the package
	if (LOCAL_NLOHMANN_JSON)
		set(JSON_BuildTests OFF CACHE INTERNAL "")
		set(JSON_Install OFF CACHE INTERNAL "")
		add_subdirectory(nlohmann_json)
	else()
		find_package(nlohmann_json REQUIRED)
	endif()
endif()

# set the paths to header files
include_directories(${SD} ${SD}io ${SD}shader ${SD}xz ${SD}engine ${SD}exceptions ${SD}xml ${SD}eye_candy)

# list the C source files
set(SOURCES
	${SD}2d_objects.c ${SD}3d_objects.c ${SD}actors.c ${SD}actor_scripts.c ${SD}alphamap.c ${SD}asc.c
	${SD}astrology.c ${SD}bags.c ${SD}bbox_tree.c ${SD}buddy.c ${SD}buffs.c ${SD}cache.c ${SD}cal.c
	${SD}calc.c ${SD}chat.c ${SD}cluster.c ${SD}colors.c ${SD}console.c ${SD}consolewin.c ${SD}counters.c
	${SD}cursors.c ${SD}dds.c ${SD}ddsimage.c ${SD}dialogues.c ${SD}draw_scene.c ${SD}elconfig.c ${SD}el_memory.c
	${SD}elwindows.c ${SD}emotes.c ${SD}encyclopedia.c ${SD}errors.c ${SD}events.c ${SD}eye_candy_debugwin.c
	${SD}filter.c ${SD}framebuffer.c ${SD}frustum.c ${SD}gamewin.c ${SD}gl_init.c ${SD}hash.c ${SD}help.c
	${SD}highlight.c ${SD}hud.c ${SD}hud_misc_window.c ${SD}hud_quickbar_window.c ${SD}hud_quickspells_window.c
	${SD}hud_statsbar_window.c ${SD}ignore.c ${SD}image.c ${SD}image_loading.c ${SD}init.c ${SD}interface.c
	${SD}items.c ${SD}keys.c ${SD}knowledge.c ${SD}langselwin.c ${SD}lights.c ${SD}list.c ${SD}load_gl_extensions.c
	${SD}loading_win.c ${SD}loginwin.c ${SD}main.c ${SD}makeargv.c ${SD}manufacture.c ${SD}map.c ${SD}mapwin.c
	${SD}md5.c ${SD}mines.c ${SD}minimap.c ${SD}misc.c ${SD}missiles.c ${SD}multiplayer.c ${SD}new_actors.c
	${SD}new_character.c ${SD}notepad.c ${SD}openingwin.c ${SD}particles.c ${SD}paste.c ${SD}pathfinder.c
	${SD}pm_log.c ${SD}popup.c ${SD}queue.c ${SD}reflection.c ${SD}rules.c ${SD}serverpopup.c ${SD}servers.c
	${SD}session.c ${SD}shader/noise.c ${SD}shader/shader.c ${SD}shadows.c ${SD}skeletons.c ${SD}skills.c ${SD}sky.c
	${SD}sound.c ${SD}special_effects.c ${SD}spells.c ${SD}stats.c ${SD}storage.c ${SD}tabs.c ${SD}text_aliases.c
	${SD}text.c ${SD}textures.c ${SD}tile_map.c ${SD}timers.c ${SD}trade.c ${SD}translate.c ${SD}update.c ${SD}url.c
	${SD}weather.c ${SD}widgets.c ${SD}io/e3d_io.c ${SD}io/elc_io.c ${SD}io/elfilewrapper.c ${SD}io/elpathwrapper.c
	${SD}io/fileutil.c ${SD}io/half.c ${SD}io/ioapi.c ${SD}io/map_io.c ${SD}io/normal.c ${SD}io/unzip.c
	${SD}io/xmlcallbacks.c ${SD}io/zip.c ${SD}io/ziputil.c ${SD}xz/7zCrc.c ${SD}xz/7zCrcOpt.c ${SD}xz/Alloc.c
	${SD}xz/Bra86.c ${SD}xz/Bra.c ${SD}xz/BraIA64.c ${SD}xz/CpuArch.c ${SD}xz/Delta.c ${SD}xz/LzFind.c
	${SD}xz/Lzma2Dec.c ${SD}xz/Lzma2Enc.c ${SD}xz/LzmaDec.c ${SD}xz/LzmaEnc.c ${SD}xz/Sha256.c ${SD}xz/Xz.c
	${SD}xz/XzCrc64.c ${SD}xz/XzDec.c ${SD}xz/XzEnc.c
)

# list the C++ source files
set(SOURCES ${SOURCES}
	${SD}achievements.cpp ${SD}actor_init.cpp  ${SD}books.cpp ${SD}cal3d_wrapper.cpp ${SD}command_queue.cpp ${SD}context_menu.cpp
	${SD}cppwindows.cpp ${SD}elloggingwrapper.cpp  ${SD}font.cpp ${SD}hud_indicators.cpp ${SD}hud_timer.cpp ${SD}icon_window.cpp
	${SD}io/cal3d_io_wrapper.cpp ${SD}item_info.cpp ${SD}item_lists.cpp ${SD}named_colours.cpp
	${SD}optimizer.cpp ${SD}password_manager.cpp ${SD}quest_log.cpp ${SD}select.cpp ${SD}sendvideoinfo.cpp
	${SD}trade_log.cpp ${SD}user_menus.cpp ${SD}xor_cipher.cpp ${SD}engine/hardwarebuffer.cpp ${SD}engine/logging.cpp
	${SD}exceptions/extendedexception.cpp ${SD}eye_candy/effect_bag.cpp ${SD}eye_candy/effect_breath.cpp
	${SD}eye_candy/effect_campfire.cpp ${SD}eye_candy/effect_candle.cpp ${SD}eye_candy/effect_cloud.cpp
	${SD}eye_candy/effect_firefly.cpp ${SD}eye_candy/effect_fountain.cpp ${SD}eye_candy/effect_glow.cpp
	${SD}eye_candy/effect_harvesting.cpp ${SD}eye_candy/effect_impact.cpp ${SD}eye_candy/effect_lamp.cpp
	${SD}eye_candy/effect_mines.cpp ${SD}eye_candy/effect_missile.cpp ${SD}eye_candy/effect_ongoing.cpp
	${SD}eye_candy/effect_selfmagic.cpp ${SD}eye_candy/effect_smoke.cpp ${SD}eye_candy/effect_staff.cpp
	${SD}eye_candy/effect_summon.cpp ${SD}eye_candy/effect_sword.cpp ${SD}eye_candy/effect_targetmagic.cpp
	${SD}eye_candy/effect_teleporter.cpp ${SD}eye_candy/effect_wind.cpp ${SD}eye_candy/eye_candy.cpp
	${SD}eye_candy/kepler_orbit.cpp ${SD}eye_candy/math_cache.cpp ${SD}eye_candy/orbital_mover.cpp
	${SD}eye_candy_wrapper.cpp ${SD}xml/xmlhelper.cpp
)

# if CUSTOM_UPDATE wanted add the define and additional source modules
if (CUSTOM_UPDATE)
	add_definitions(-DCUSTOM_UPDATE)
	set(SOURCES ${SOURCES} ${SD}custom_update.c ${SD}new_update.c)
endif()

# if JSON_FILES wanted add the define and additional source modules
if (JSON_FILES)
	add_definitions(-DJSON_FILES)
	set(SOURCES ${SOURCES} ${SD}json_io.cpp )
endif()

# if FSAA wanted add the define and additional source modules
if (FSAA)
	add_definitions(-DFSAA)
	if (CMAKE_SYSTEM_NAME MATCHES "Windows")
		set(SOURCES ${SOURCES} ${SD}fsaa/fsaa_wgl.c ${SD}fsaa/fsaa.c)
	else()

=== map_editor/CMakeLists.txt ===
# CMAKE file for Eternal Lands Map Editor
#
# Create a build sub-directory and move into it
# 
# To build a normal release version
#   cmake <path to source>
#
# Build Debug vesion
#   cmake -DCMAKE_BUILD_TYPE=debug <path to source>
#
# To specify a non-default exec name include -DEXEC, for example "-DEXEC=el.mapeditor.$(uname -m).linux.bin"
# To enable local CPU architecture optimisation include "-DMARCHNATIVE=1"
# To enable runtime GCC address sanitization include -DADDRSANITISER=1
#
# Example if located in source directory:
#   mkdir -p build && cd build
#   cmake -DCMAKE_BUILD_TYPE=debug -DEXEC=el.$(uname -m).linux.bin -DMARCHNATIVE=1 -DADDRSANITISER=1 ..
#   make
#
# Example for windows using msys2
#   cmake -G "MSYS Makefiles" -DCMAKE_INCLUDE_PATH="/mingw64/local/include" -DCMAKE_LIBRARY_PATH="/mingw64/local/lib" ..

cmake_minimum_required(VERSION 3.0.2)

project (Eternal-Lands-Map-Editor)

# standard options
add_definitions(
	-DEYE_CANDY						# special effects
	-DCLUSTER_INSIDES				# Group objects into separate clusters for clipping on inside maps
	-DNEW_LIGHT_FORMAT				# ??
	-DZLIB							# use gz() libraries
	-DZLIBW							# use gz() libraries (same ???)
)

# Set the path from the git root to the map editor source files
set(SD "")

# Get compiler flags for used libraries
include(FindPkgConfig)
pkg_check_modules(SDL sdl)
if (NOT SDL_INCLUDE_DIRS)
	include(FindSDL)
endif()
include(FindLibXml2)
include(FindSDL_image)
set(OpenGL_GL_PREFERENCE LEGACY)
include(FindOpenGL)
include(FindZLIB)
include(FindPNG)
include(FindX11)
include(FindGTK2)
if (CMAKE_SYSTEM_NAME MATCHES "Windows")
	include(FindIconv)
endif()
include(../cmake/FindCal3d.cmake)

# set the paths to header files
include_directories(${SD}. ${SD}../ ${SD}../io ${SD}../xz ${SD}../engine ${SD}../exceptions ${SD}../eye_candy)

# list the map editor C source files
set(SOURCES
	${SD}2d_objects.c ${SD}3d_objects.c ${SD}browser.c ${SD}draw_scene.c ${SD}e3d.c
	${SD}elwindows.c ${SD}events.c ${SD}font.c ${SD}frustum.c ${SD}gl_init.c ${SD}global.c
	${SD}gui.c ${SD}gui_callbacks.c ${SD}init.c ${SD}interface.c ${SD}lights.c ${SD}main.c
	${SD}map_io.c ${SD}misc.c ${SD}o3dow.c ${SD}${SD}reflection.c ${SD}shadows.c ${SD}tile_map.c
	${SD}replace_window.c ${SD}edit_window.c ${SD}particles_window.c
)

# list the client C source files
set(SOURCES ${SOURCES}
	${SD}../asc.c ${SD}../colors.c ${SD}../elconfig.c ${SD}../errors.c ${SD}../load_gl_extensions.c
	${SD}../md5.c ${SD}../dds.c ${SD}../ddsimage.c ${SD}../el_memory.c ${SD}../particles.c
	${SD}../queue.c ${SD}../textures.c ${SD}../translate.c ${SD}../hash.c ${SD}../image.c
	${SD}../image_loading.c ${SD}../cache.c ${SD}../cluster.c
	${SD}../io/fileutil.c ${SD}../io/e3d_io.c ${SD}../io/elc_io.c ${SD}../io/elpathwrapper.c
	${SD}../io/half.c ${SD}../io/normal.c ${SD}../io/elfilewrapper.c ${SD}../io/unzip.c
	${SD}../io/ioapi.c ${SD}../io/zip.c ${SD}../io/ziputil.c
	${SD}../xz/7zCrc.c ${SD}../xz/7zCrcOpt.c ${SD}../xz/Alloc.c ${SD}../xz/Bra86.c ${SD}../xz/Bra.c
	${SD}../xz/BraIA64.c ${SD}../xz/CpuArch.c ${SD}../xz/Delta.c ${SD}../xz/LzFind.c
	${SD}../xz/Lzma2Dec.c ${SD}../xz/Lzma2Enc.c ${SD}../xz/LzmaDec.c ${SD}../xz/LzmaEnc.c
	${SD}../xz/Sha256.c ${SD}../xz/Xz.c ${SD}../xz/XzCrc64.c ${SD}../xz/XzDec.c ${SD}../xz/XzEnc.c
)

# list the map editor C++ source files
set(SOURCES ${SOURCES}
	${SD}eye_candy_window.cpp
)

# list the client C++ source files
set(SOURCES ${SOURCES}
	${SD}../elloggingwrapper.cpp ${SD}../cal3d_wrapper.cpp
	${SD}../eye_candy_wrapper.cpp
	${SD}../engine/hardwarebuffer.cpp ${SD}../engine/logging.cpp
	${SD}../exceptions/extendedexception.cpp
	${SD}../eye_candy/effect_bag.cpp ${SD}../eye_candy/effect_breath.cpp
	${SD}../eye_candy/effect_campfire.cpp ${SD}../eye_candy/effect_cloud.cpp
	${SD}../eye_candy/effect_candle.cpp ${SD}../eye_candy/effect_firefly.cpp
	${SD}../eye_candy/effect_fountain.cpp ${SD}../eye_candy/effect_glow.cpp
	${SD}../eye_candy/effect_harvesting.cpp ${SD}../eye_candy/effect_impact.cpp
	${SD}../eye_candy/effect_lamp.cpp ${SD}../eye_candy/effect_ongoing.cpp
	${SD}../eye_candy/effect_selfmagic.cpp ${SD}../eye_candy/effect_smoke.cpp
	${SD}../eye_candy/effect_summon.cpp ${SD}../eye_candy/effect_sword.cpp
	${SD}../eye_candy/effect_targetmagic.cpp ${SD}../eye_candy/effect_teleporter.cpp
	${SD}../eye_candy/effect_wind.cpp ${SD}../eye_candy/eye_candy.cpp
	${SD}../eye_candy/math_cache.cpp
)

# if enabled, build a exec optomised for the hosts CPU architecture, this is not portable
if (MARCHNATIVE)
	set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -march=native")
	set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -march=native")
endif()

# if enabled, include the gcc address sanitisation options, please report andthing you find
if (ADDRSANITISER)
	set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -fsanitize=address")
	set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fsanitize=address")
	set(EXTRA_LD_FLAGS "${EXTRA_LD_FLAGS} -fsanitize=address")
endif()

# set the compiler flags for DEBUG and RELEASE builds
set(CMAKE_C_FLAGS "${EXTRA_C_FLAGS} -Wall -Wdeclaration-after-statement -D_GNU_SOURCE=1 -D_REENTRANT")
set(CMAKE_C_FLAGS_DEBUG "-Og -ggdb -pipe -fno-strict-aliasing")
set(CMAKE_C_FLAGS_RELEASE "-O3 -fomit-frame-pointer -ffast-math -pipe -fno-strict-aliasing")
set(CMAKE_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wall -D_GNU_SOURCE=1 -D_REENTRANT")
set(CMAKE_CXX_FLAGS_DEBUG "-Og -ggdb -pipe -fno-strict-aliasing")
set(CMAKE_CXX_FLAGS_RELEASE "-O3 -fomit-frame-pointer -ffast-math -pipe -fno-strict-aliasing")

# set the OS level defines and default executable names
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	if (NOT EXEC)
		set(EXEC "mapedit.linux.bin")
	endif()
	add_definitions(-DLINUX)
elseif (CMAKE_SYSTEM_NAME MATCHES "Windows")
	if (NOT EXEC)
		set(EXEC "mapedit")
	endif()
	add_definitions(-DWINDOWS -DWINVER=0x500 -mwindows -DNDEBUG)
	set(EXTRA_LD_FLAGS "${EXTRA_LD_FLAGS} -mwindows")
	set(SOURCES ${SOURCES} ${SD}mapedit.rc)
	set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -i <SOURCE> -o <OBJECT>")
	set(GTK2_GDKCONFIG_INCLUDE_DIR /mingw64/lib/gtk-2.0/include)
	set(GTK2_GLIBCONFIG_INCLUDE_DIR /mingw64/lib/glib-2.0/include)
	set(GTK2_LIBRARIES ${GTK2_LIBRARIES} ${GTK2_ATK_LIBRARY}
		${GTK2_CAIRO_LIBRARY} ${GTK2_FONTCONFIG_LIBRARY}
		${GTK2_GDKCONFIG_LIBRARY} ${GTK2_GDK_LIBRARY}
		${GTK2_GDK_PIXBUF_LIBRARY} ${GTK2_GLIBCONFIG_LIBRARY}
		${GTK2_GLIB_LIBRARY} ${GTK2_GOBJECT_LIBRARY} ${GTK2_GTK_LIBRARY}
		${GTK2_HARFBUZZ_LIBRARY} ${GTK2_PANGOCAIRO_LIBRARY}
		${GTK2_PANGO_LIBRARY} ${GTK2_X11_LIBRARY})
	set(GTK2_INCLUDE_DIRS ${GTK2_INCLUDE_DIRS} ${GTK2_ATK_INCLUDE_DIR}
		${GTK2_CAIRO_INCLUDE_DIR} ${GTK2_FONTCONFIG_INCLUDE_DIR}
		${GTK2_GDKCONFIG_INCLUDE_DIR} ${GTK2_GDK_INCLUDE_DIR}
		${GTK2_GDK_PIXBUF_INCLUDE_DIR} ${GTK2_GLIBCONFIG_INCLUDE_DIR}
		${GTK2_GLIB_INCLUDE_DIR} ${GTK2_GOBJECT_INCLUDE_DIR}
		${GTK2_GTK_INCLUDE_DIR} ${GTK2_HARFBUZZ_INCLUDE_DIR}
		${GTK2_PANGOCAIRO_INCLUDE_DIR} ${GTK2_PANGO_INCLUDE_DIR}
		${GTK2_X11_INCLUDE_DIR})
else()
	message( FATAL_ERROR "Unknown platform [${CMAKE_SYSTEM_NAME}]" )
endif()

# any final defines needed
add_definitions(-DMAP_EDITOR -D_7ZIP_ST -DGTK2 ${GTK2_DEFINITIONS})

# default to building a release version
if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE release)
endif()

# clean up extra strings to avoid policy CMP0004
string(STRIP "${EXTRA_C_FLAGS}" EXTRA_C_FLAGS)
string(STRIP "${EXTRA_CXX_FLAGS}" EXTRA_CXX_FLAGS)
string(STRIP "${EXTRA_LD_FLAGS}" EXTRA_LD_FLAGS)

# build

add_executable(${EXEC} ${SOURCES})

target_link_libraries(${EXEC}
	${EXTRA_LD_FLAGS}
	${SDL_LIBRARY} ${SDL_LIBRARIES}
	${LIBXML2_LIBRARIES}
	${CAL3D_LIBRARIES}
	${SDL_IMAGE_LIBRARY}
	${OPENGL_LIBRARIES}
	${PNG_LIBRARIES}
	${X11_LIBRARIES}
	${GTK2_LIBRARIES}
	${Iconv_LIBRARIES}
	${OPENGL_gl_LIBRARY}
	${OPENGL_glu_LIBRARY}
	${STATIC_LIBRARIES}
)

target_include_directories(${EXEC} SYSTEM PUBLIC
	${SDL_INCLUDE_DIR} ${SDL_INCLUDE_DIRS}
	${LIBXML2_INCLUDE_DIR}
	${CAL3D_INCLUDE_DIR}
	${SDL_IMAGE_INCLUDE_DIR}
	${OPENGL_INCLUDE_DIR}
	${ZLIB_INCLUDE_DIRS}
	${PNG_INCLUDE_DIRS}
	${X11_INCLUDE_DIR}
	${GTK2_INCLUDE_DIRS}
	${Iconv_INCLUDE_DIRS}
)

=== nlohmann_json/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

##
## PROJECT
## name and version
##
project(nlohmann_json VERSION 3.10.4 LANGUAGES CXX)

##
## MAIN_PROJECT CHECK
## determine if nlohmann_json is built as a subproject (using add_subdirectory) or if it is the main project
##
set(MAIN_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(MAIN_PROJECT ON)
endif()

##
## INCLUDE
##
##
include(ExternalProject)

##
## OPTIONS
##

if (POLICY CMP0077)
    # Allow CMake 3.13+ to override options when using FetchContent / add_subdirectory.
    cmake_policy(SET CMP0077 NEW)
endif ()

option(JSON_BuildTests          "Build the unit tests when BUILD_TESTING is enabled." ${MAIN_PROJECT})
option(JSON_CI                  "Enable CI build targets." OFF)
option(JSON_Diagnostics         "Use extended diagnostic messages." OFF)
option(JSON_ImplicitConversions "Enable implicit conversions." ON)
option(JSON_Install             "Install CMake targets during install step." ${MAIN_PROJECT})
option(JSON_MultipleHeaders     "Use non-amalgamated version of the library." OFF)
option(JSON_SystemInclude       "Include as system headers (skip for clang-tidy)." OFF)

if (JSON_CI)
    include(cmake/ci.cmake)
endif ()

##
## CONFIGURATION
##
include(GNUInstallDirs)

set(NLOHMANN_JSON_TARGET_NAME               ${PROJECT_NAME})
set(NLOHMANN_JSON_CONFIG_INSTALL_DIR        "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}" CACHE INTERNAL "")
set(NLOHMANN_JSON_INCLUDE_INSTALL_DIR       "${CMAKE_INSTALL_INCLUDEDIR}")
set(NLOHMANN_JSON_TARGETS_EXPORT_NAME       "${PROJECT_NAME}Targets")
set(NLOHMANN_JSON_CMAKE_CONFIG_TEMPLATE     "cmake/config.cmake.in")
set(NLOHMANN_JSON_CMAKE_CONFIG_DIR          "${CMAKE_CURRENT_BINARY_DIR}")
set(NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}ConfigVersion.cmake")
set(NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}Config.cmake")
set(NLOHMANN_JSON_CMAKE_PROJECT_TARGETS_FILE "${NLOHMANN_JSON_CMAKE_CONFIG_DIR}/${PROJECT_NAME}Targets.cmake")
set(NLOHMANN_JSON_PKGCONFIG_INSTALL_DIR     "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

if (JSON_MultipleHeaders)
    set(NLOHMANN_JSON_INCLUDE_BUILD_DIR "${PROJECT_SOURCE_DIR}/include/")
    message(STATUS "Using the multi-header code from ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}")
else()
    set(NLOHMANN_JSON_INCLUDE_BUILD_DIR "${PROJECT_SOURCE_DIR}/single_include/")
    message(STATUS "Using the single-header code from ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}")
endif()

if (NOT JSON_ImplicitConversions)
    message(STATUS "Implicit conversions are disabled")
endif()

if (JSON_Diagnostics)
    message(STATUS "Diagnostics enabled")
endif()

if (JSON_SystemInclude)
    set(NLOHMANN_JSON_SYSTEM_INCLUDE "SYSTEM")
endif()

##
## TARGET
## create target and add include path
##
add_library(${NLOHMANN_JSON_TARGET_NAME} INTERFACE)
add_library(${PROJECT_NAME}::${NLOHMANN_JSON_TARGET_NAME} ALIAS ${NLOHMANN_JSON_TARGET_NAME})
if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
    target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_range_for)
else()
    target_compile_features(${NLOHMANN_JSON_TARGET_NAME} INTERFACE cxx_std_11)
endif()

target_compile_definitions(
    ${NLOHMANN_JSON_TARGET_NAME}
    INTERFACE
    JSON_USE_IMPLICIT_CONVERSIONS=$<BOOL:${JSON_ImplicitConversions}>
    JSON_DIAGNOSTICS=$<BOOL:${JSON_Diagnostics}>
)

target_include_directories(
    ${NLOHMANN_JSON_TARGET_NAME}
    ${NLOHMANN_JSON_SYSTEM_INCLUDE} INTERFACE
    $<BUILD_INTERFACE:${NLOHMANN_JSON_INCLUDE_BUILD_DIR}>
    $<INSTALL_INTERFACE:include>
)

## add debug view definition file for msvc (natvis)
if (MSVC)
    set(NLOHMANN_ADD_NATVIS TRUE)
    set(NLOHMANN_NATVIS_FILE "nlohmann_json.natvis")
    target_sources(
        ${NLOHMANN_JSON_TARGET_NAME}
        INTERFACE
            $<INSTALL_INTERFACE:${NLOHMANN_NATVIS_FILE}>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${NLOHMANN_NATVIS_FILE}>
    )
endif()

# Install a pkg-config file, so other tools can find this.
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/pkg-config.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
)

##
## TESTS
## create and configure the unit test target
##
if (JSON_BuildTests)
    include(CTest)
    enable_testing()
    add_subdirectory(test)
endif()

##
## INSTALL
## install header files, generate and install cmake config files for find_package()
##
include(CMakePackageConfigHelpers)
# use a custom package version config file instead of
# write_basic_package_version_file to ensure that it's architecture-independent
# https://github.com/nlohmann/json/issues/1697
configure_file(
    "cmake/nlohmann_jsonConfigVersion.cmake.in"
    ${NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE}
    @ONLY
)
configure_file(
    ${NLOHMANN_JSON_CMAKE_CONFIG_TEMPLATE}
    ${NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE}
    @ONLY
)

if(JSON_Install)
    install(
        DIRECTORY ${NLOHMANN_JSON_INCLUDE_BUILD_DIR}
        DESTINATION ${NLOHMANN_JSON_INCLUDE_INSTALL_DIR}
    )
    install(
        FILES ${NLOHMANN_JSON_CMAKE_PROJECT_CONFIG_FILE} ${NLOHMANN_JSON_CMAKE_VERSION_CONFIG_FILE}
        DESTINATION ${NLOHMANN_JSON_CONFIG_INSTALL_DIR}
    )
    if (NLOHMANN_ADD_NATVIS)
        install(
            FILES ${NLOHMANN_NATVIS_FILE}
            DESTINATION .
    )
    endif()
    export(
        TARGETS ${NLOHMANN_JSON_TARGET_NAME}
        NAMESPACE ${PROJECT_NAME}::
        FILE ${NLOHMANN_JSON_CMAKE_PROJECT_TARGETS_FILE}
    )
    install(
        TARGETS ${NLOHMANN_JSON_TARGET_NAME}
        EXPORT ${NLOHMANN_JSON_TARGETS_EXPORT_NAME}
        INCLUDES DESTINATION ${NLOHMANN_JSON_INCLUDE_INSTALL_DIR}
    )
    install(
        EXPORT ${NLOHMANN_JSON_TARGETS_EXPORT_NAME}
        NAMESPACE ${PROJECT_NAME}::
        DESTINATION ${NLOHMANN_JSON_CONFIG_INSTALL_DIR}
    )
    install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
        DESTINATION ${NLOHMANN_JSON_PKGCONFIG_INSTALL_DIR}
    )
endif()

=== debian/changelog ===
eternallands (1.9.6.1-0ubuntu1) bionic; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 11:18:07 +0000

=== pkgfiles/debs/data/debian/changelog ===
eternallands-data (1.9.6.1-0ubuntu1) bionic; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 11:47:25 +0000

=== pkgfiles/debs/music/debian/changelog ===
eternallands-music (1.9.5.9-0ubuntu1) xenial; urgency=low

  * 1.9.5p9 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Fri, 09 Apr 2021 15:25:07 +0100

=== pkgfiles/debs/sound/debian/changelog ===
eternallands-sound (1.9.6.1-0ubuntu1) xenial; urgency=low

  * 1.9.6.1 release

 -- Paul Broadhead <pjbroad@twinmoons.org.uk>  Sat, 12 Mar 2022 12:43:10 +0000

=== debian/control ===
Source: eternallands
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9), libsdl2-dev, libsdl2-net-dev, libsdl2-image-dev, libsdl2-ttf-dev, libxml2-dev, libogg-dev, libvorbis-dev, libopenal-dev, libcal3d12-dev, libxrandr-dev, zlib1g-dev, libpng12-dev|libpng-dev, libssl-dev, cmake
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, eternallands-data (>=1.9.6), zenity
Recommends: eternallands-sound (>=1.9.5)
Suggests: eternallands-music (>=1.9.5)
Description: client package for Eternal Lands, a free MMORPG 
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal.

=== pkgfiles/debs/data/debian/control ===
Source: eternallands-data
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands-data
Architecture: all
Depends: ${misc:Depends}, wget (>>1), unzip (>>2), findutils (>>4), eternallands (>=1.9.6)
Recommends: eternallands-sound (>=1.9.6)
Suggests: eternallands-music (>=1.9.5)
Description: data package for Eternal Lands, a free MMORPG
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal. 
 .
 NOTE: This package will download and install the Eternal Lands data
 archive from twinmoons.org.uk.  This file is the same as the official
 release but hosted to ensure the package continues to work if the
 archive is moved or modified.

=== pkgfiles/debs/music/debian/control ===
Source: eternallands-music
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands-music
Architecture: all
Depends: wget (>>1), unzip (>>2), findutils (>>4), eternallands (>=1.9.5), eternallands-data (>=1.9.5)
Description: the music package for Eternal Lands, a free MMORPG
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal. 
 .
 WARNING: Installing this package causes the Eternal Lands music to be
 downloaded from twinmoons.org.uk and installed.

=== pkgfiles/debs/sound/debian/control ===
Source: eternallands-sound
Section: games
Priority: optional
Maintainer: Paul Broadhead <pjbroad@twinmoons.org.uk>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.7
Homepage: http://www.eternal-lands.com

Package: eternallands-sound
Architecture: all
Depends: ${misc:Depends}, wget (>>1), unzip (>>2), findutils (>>4), eternallands (>=1.9.6), eternallands-data (>=1.9.6)
Description: sound package for Eternal Lands, a free MMORPG
 Eternal Lands is a free to play, graphical MMORPG (massively-multi-player
 online role-playing game).  Different from other role-playing games, there are
 no fixed classes so you can improve any of the many skills.  There is a choice
 of several character races but all are equal. 
 .
 NOTE: This package will download and install the Eternal Lands sound
 archive from twinmoons.org.uk.  This file is the same as the official
 release but hosted to ensure the package continues to work if the
 archive is moved or modified.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Commands to configure the package.

	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Commands to compile the package.
	mkdir -p build && \
		cd build && \
		cmake -DLOCAL_NLOHMANN_JSON=On -DEXEC=el.linux.bin .. && \
		make
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Commands to clean up after the build process.
	rm -rf build

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs CHANGES
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installmenu
	dh_installman pkgfiles/eternallands.6 pkgfiles/el.linux.bin.6
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== pkgfiles/debs/data/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean 

PKGTAG = eternallands-data
DEST = $(CURDIR)/debian/$(PKGTAG)/usr/share/games/EternalLands
CACHE = $(CURDIR)/debian/$(PKGTAG)/var/cache/eternallands

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	install -d $(DEST) $(CACHE)
	touch $(DEST)/$(PKGTAG).filelist $(DEST)/$(PKGTAG).dirlist

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_install
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=3

# Source is at https://github.com/raduprv/Eternal-Lands

=== pkgfiles/debs/data/debian/watch ===
version=3

# There is no source to watch.
# This package purely downloads and installs game binary data.
